<?php

/**
 * Klasse Acl
 * Zeigt alle Einträge von der Tabelle acl der Datenbank
 */
class Acl {
    
    private $bc;

    function __construct() {
        require_once('/usr/fallback/beroConf.php');
        $this->bc= new beroConf('root');
    }
    
    function allowLan() {
        $excludelan = $this->bc->get("root", "excludelan");
        ($excludelan == 1) ? $checked = "" : $checked = "checked";
        return "<input type='hidden' name='allowlan' value='1'>"
                . "<input type='checkbox' name='allowlan' id='allowcheck' value='0' $checked>";
    }

    private function _save() {
        $this->bc->set("root", "excludelan",$_POST['allowlan']);
        return Helper::activate(1, true, $_GET['m'], ACTIVATE);
    }


    /*
     * Funktion display erzeugt den Inhalt von der HTML-Seite
     */

    function display() {

        include "./includes/functions.php";
        //Das Objekt funktions wird erzeugt um später die Navigationsleiste zu erzeugen.
        $functions = new functions();

        // args
        $m = $_GET['m'];
        $q = $_GET['q'];
        $start = $_GET['start'];
        $order = $_GET['order'];
        $sort = $_GET['sort'];

        $ba = new beroAri();

        $span = 15;
        $query = $ba->select('SELECT * FROM acl');
        $record_count = sqlite_num_rows($query);
        $test = $record_count / $span;
        $test = (int) $test;
        if ($record_count == 0) {
            $next_add = 0;
        } else {
            $next_add = ($test * $span);
        }

        $start = $start == '' ? 0 : $start;
        $order = $order;
        $sort = $sort;
        $name="ACL_TITLE_DIS";
        include('./includes/header.php');
        $acl_table = $this->dynamic_table();

        // build page content
        $ret .= "<script>
			function popup(param)
			{
				$.ajax({
					url : 'modules/Acl/acl_popup.php?'+param,
					success : function (data) {
						$('#dialog').html(data);

						$('#dialog').dialog({ minWidth: 450, title: '" . ACL_TITLE_DIS . "' });
                                               hide_elements();
					       required();
					}
				});
			}

			function del(table,option){
				conf = confirm('" . ACL_DELETE_MESS1_DIS . "? ');
				if (conf==false)
					return false;
				else
					window.location='./misc/delete.php?m=".$_GET['m']."&id='+option+'&table='+table;
			}
		</script>
		<div id='dialog'></div>
		<br>
		<div id='content'>
		" . $acl_table . "
		</div>
		<form class='beroari_form' name='acl' action='' method='GET'>
		<input type=hidden name=m value='" . $m . "'>
		<input type=hidden name=f value='action'>
		<input type=hidden name=q value='" . $q . "'>
		<input type=hidden name=start value='" . $next_add . "'>
		<input type=hidden name=span value='" . $span . "'>
		<input type=hidden name=order value='" . $order . "'>
		<input type=hidden name=sort value='" . $sort . "'>
		<input type=hidden name=a value='add'>
		<div class='center'><input name='submit' type='button' value='" . BUTTON_ADD . "' onclick='popup(\"start=" . $start . "\");'></div>
		</form>";

        //ein neues Datenbankobjekt wird erzeugt.
        $ba = new beroAri();

        //Erzeugung der Navigationsleiste.
        $query = $ba->select('SELECT * FROM acl');
        $record_count = sqlite_num_rows($query);
        $url_opts = array();
        $url_opts['sort'] = $sort;
        $url_opts['order'] = $order;
        $ret .= $functions->displayNavigationBlock($m, $q, $url_opts, $start, $span, $record_count);
        
        //Allow all access from LAN
        
        if (isset($_POST['allowlan'])) $ret.=$this->_save();

        $ret .= "<br /><form class='extensions_form' action='' class='allow' method='POST'>
        <input type=hidden name=m value='" . $m . "'>
        <table class='contenttoc' style='width:500px;'>
        <tr>
        <td><b>" . ACL_ALLOW_LAN_DIS . ":</b></td>
        <td>" . $this->allowLan() . "
        <div id='warning_allowlan' style='font-style: italic; color:red;'></div>    
        </td>
        </tr>
        <tr>
        <td colspan='2'><input name='submit' type='submit' value='" . BUTTON_SAVE . "'>
        </td>
        </tr>
        </table>
        <br>
        </form>
        <script>$('#allowcheck').change(function() {
            if ($('#allowcheck').is(':checked')==false)
                $('#warning_allowlan').html('".ACL_MESSAGE_DIS."');
            else
                $('#warning_allowlan').html('');
        }); </script>";

        //Rückgabe: Inhalt der HTML-Seite
        return $ret;
    }

    /*
     * Funktion dynamic_table
     */

    function dynamic_table() {
        //ein neues Datenbankobjekt wird erzeugt.
        $ba = new beroAri();
        require_once("./includes/lang.php");
        $start = $_GET['start'];

        //Das Header der Tabelle sind die Spaltennamen von acl
        $columns = $ba->column_type('acl');
        $i = 0;
        $columnsToShow = array("protocol", "dest_port", "address", "netmask");
        $colName = array("protocol" => ACL_PROTOCOL_DIS, "dest_port" => ACL_DEST_PORT_DIS, "address" => ACL_ADDRESS_DIS, "netmask" => ACL_NETMASK_DIS);
        foreach ($columns as $column => $type) {
            if (in_array($column, $columnsToShow))
                $cols .= "<th>" . $colName[$column] . "</th>";
        }

        /* Die Einträge werden von der Tabelle acl gelesen, formatiert und in einer
          Tabelle geschrieben, zusätzlich werden 2 Knöpfe eingebaut: modify und delete */
        $page = (($start / 15) + 1);
        if (!$start)
            $start = 0;
        $id = 0;
        $ports = array(-1 => "SIP", -2 => "SIP-TLS", 80 => "HTTP", 443 => "HTTPS", 54322 => "Telnet", 22 => "SSH", 161 => "SNMP", 162 => "SNMP-Trap", 65001 => "bfdetect", "all"=>"All");
        $protocol = array("" => "All", "udp" => "UDP", "tcp" => "TCP");
        for ($j = 1; $j <= $page; $j++) {
            $query = $ba->select('SELECT * FROM acl ORDER BY id asc limit 15 offset ' . $start);
            $rows = '';
            while ($entry = $ba->fetch_array($query)) {
                $rows .= "<tr>";
                for ($i = 0; $i < (count($columnsToShow)); $i++) {
                    $col_name = $columnsToShow[$i];
                    if ($col_name == "dest_port" && (array_key_exists($entry[$col_name], $ports)))
                        $entry[$col_name] = $ports[$entry[$col_name]];
                    elseif (($col_name == "protocol" && (array_key_exists($entry[$col_name], $protocol))))
                        $entry[$col_name] = $protocol[$entry[$col_name]];
                    $rows .= "<td>" . $entry[$col_name] . "</td>";
                }
                $id = $entry['id'];
                $rows .= "<td class='buttons'>
				<a class='popup_download' onclick=\"javascript:popup('id=" . $id . "');\" >
					<img src='./includes/images/modify.png'>
				</a>&nbsp;
				<a class='popup_download' onclick=\"del('acl','" . $id . "');\">
            	    <img src='./includes/images/delete.png'>
				</a>
				</td></tr>";
            }
        }

        $table = "<table class='contenttoc' id='table'><tr>" . $cols . "<th></th></tr>" . $rows . "</table>";
        //Rückgabe: Erzeugte Tabelle mit den Einträgen der Tabelle acl der Datenbank
        return $table;
    }

}

?>
