<?php

/**
 * Class for network settings
 */
class NetConf {

	function save($ba, $bc) {

		if ($_POST['action'] == 'apply') {
			# configure basic network settings
			$bc->set('root', 'lan-dhcp', sqlite_escape_string($_POST['dhcp']));
			if (in_array($bc->get('root', 'lan-dhcp'), array('yes', '1'))) {
				# delete everything, as it's configured by dhcp
				foreach (array('lan-ipaddr', 'lan-netmask', 'lan-gateway', 'lan-nameserver', 'lan-mtu') as $field) {
					$bc->delete('root', $field);
				}
			} else {
				# configure static networking
				$bc->set('root', 'lan-ipaddr', sqlite_escape_string($_POST['ipaddr']));
				$bc->set('root', 'lan-netmask', sqlite_escape_string($_POST['netmask']));
				$bc->set('root', 'lan-gateway', sqlite_escape_string($_POST['gateway']));
				$bc->set('root', 'lan-mtu', sqlite_escape_string(intval($_POST['lan_mtu'])));

				# configure nameservers
				if (strlen($_POST['lan_nameserver']) != 0) {
					$nameserver = $_POST['lan_nameserver'] . ((strlen($_POST['lan_nameserver2']) != 0) ? ';' . $_POST['lan_nameserver2'] : '');
					$bc->set('root', 'lan-nameserver', sqlite_escape_string($nameserver));
				} else {
					$bc->delete('root', 'lan-nameserver');
				}
			}

			# configure misc. network settings
			$ba->set('root', 'hostname', sqlite_escape_string($_POST['hostname']));
			$bc->set('root', 'disable_ncs', (isset($_POST['disable_ncs']) ? '1' : '0'));
			$bc->set('root', 'beroAvahi-enabled', (isset($_POST['beroAvahi-enabled']) ? '1' : '0'));

			# configure vlan
			if (isset($_POST['vlanenable'])) {
				$bc->set('root', 'vlan-enable', sqlite_escape_string($_POST['vlanenable']));
				$bc->set('root', 'vlan-id', sqlite_escape_string($_POST['vlanid']));
				$bc->set('root', 'vlan-prio', sqlite_escape_string($_POST['vlan-prio']));
			} else {
				$bc->delete('root', 'vlan-enable');
				$bc->delete('root', 'vlan-id');
				$bc->delete('root', 'vlan-prio');
			}
			# configure routing
			$routing = '';
			for ($i = 0; $i < count($_POST['route_net']); $i++) {
				if (($_POST['route_net'][$i] != '') && ($_POST['route_netmask'][$i] != '') && ($_POST['route_gateway'][$i] != '')) {
					$routing .= ((strlen($routing) != 0) ? ',' : '') . $_POST['route_net'][$i] . "/" . $_POST['route_netmask'][$i] . "/" . $_POST['route_gateway'][$i];
				}
			}
			$bc->set('root', 'routing', $routing);

			$ret = Helper::activate(3, true, $_GET['m'], ACTIVATE) .
				'<br /><div class="center"><b><font color="red">' . NETWORK_CONFIGURATION_APPLIED_DIS . '</font></b></div>' . "\n";
		}
		if (isset($_POST['httpsOnly'])) {
			$ba->set('httpsOnly', sqlite_escape_string($_POST['httpsOnly']));
			$option = 1;

			$file_name = $_FILES["uploadfile"]["name"];
			$tmp_file = $_FILES["uploadfile"]["tmp_name"];
			if ($_FILES["uploadfile"]["name"] != "") {
				if ($_FILES["uploadfile"]["size"] > 51200) { //50 kB
					$ret="<div class='center'><img src='./includes/images/punkt_rot.gif'><font color='red'>" . HTTPS_INVALID_FILE_SIZE . "</font></div>";
				} else {
					exec('/usr/local/bin/openssl x509 -in ' . $tmp_file . ' -noout -text', $output, $ret);
					if ($ret == 0) {
						@unlink("/usr/conf/berofix.pem");
						exec("/bin/cp " . $tmp_file . " /usr/conf/berofix.pem");
						$option = 3;
						$ret.="<div class='center'><img src='./includes/images/punkt_gruen.gif' /><font color='black'>" . SIP_GENERAL_UPLOAD_SUCCESS_DIS . "</font></div>";
					} else {
						$ret.="<div class='center'><img src='./includes/images/punkt_rot.gif'><font color='red'>" . HTTPS_INVALID_CERT_ERROR . "</font></div>";
					}
				}
			}
			$ret.=Helper::activate($option, true, $_GET['m'], ACTIVATE);
		}


		return($ret);
	}

	function display() {
		$name = "NETWORK_TITLE_DIS";
		include('./includes/header.php');
		include('/usr/fallback/beroConf.php');

		require_once('./includes/lang.php');

		$bc = new beroConf('root');
		$ba = new beroAri();

		if (!$bc->valid()) {
			$ret.= '<h3>Error:</h3><b>Failed to connect to config database!</b><br />';
			exit(0);
		}

		// args
		$m = $_GET['m'];
		$q = $_GET['q'];
		if (isset($_POST['httpsOnly'])) {
			$ret .= $this->save($ba, $bc);
		} elseif ($_POST['action'] == 'apply') {
			if ($_POST['dhcp'] == 'yes') {
				$ret .= $this->save($ba, $bc);
			} else {
				if ($_POST['ipaddr'] != $_POST['gateway']) {
					$result = exec('/usr/sbin/netconfigverify ' . $_POST['ipaddr'] . ' ' . $_POST['netmask'] . ' ' . $_POST['gateway'] . ' 2>&1');
					if (substr_count($result, 'Failed') > 0) {
						$ret .= '<br /><div class="center"><b><font color="red">' . NETWORK_FAILED_ERROR_DIS . '</font></b></div>' . "\n";
					} else {
						$ret .= $this->save($ba, $bc);
					}
				} else {
					$ret .= '<br /><div class="center"><font color=red><b>' . NETWORK_FAILED_ERROR_DIS . '</b></font></div>' . "\n";
				}
			}
		}


		$iface = $bc->get('root', 'lan-iface');
		$dns = explode(';', $bc->get('root', 'lan-nameserver'));
		$dhcp = in_array($bc->get('root', 'lan-dhcp'), array('yes', '1'));
		//Show default values for DNS and secondary DNS
		if ($dhcp) {
			$dns[0] = '8.8.8.8';
			$dns[1] = '8.8.4.4';
		}
		
		if($ba->get('gui_mode')=='simple') $simple_class='simple';

		$ret .= '<script>' . "\n" .
			'function show_vlan (ch) {' . "\n" .
			'if (!ch) {' . "\n" .
			'$("#vlan_id").hide();' . "\n" .
			'$("#vlan_prio").hide();' . "\n" .
			'} else {' . "\n" .
			'$("#vlan_id").show();' . "\n" .
			'$("#vlan_prio").show();' . "\n" .
			'}' . "\n" .
			'}' . "\n" .
			'function hide_netconfig (ch) {' . "\n" .
			'if (!ch) {' . "\n" .
			'$("#lan_ipaddr").hide();' . "\n" .
			'$("#lan_netmask").hide();' . "\n" .
			'$("#lan_gateway").hide();' . "\n" .
			'$("#lan_dns1").hide();' . "\n" .
			'$("#lan_dns2").hide();' . "\n" .
			'$("#lan_mtusize").hide();' . "\n" .
			'} else {' . "\n" .
			'$("#lan_ipaddr").show();' . "\n" .
			'$("#lan_netmask").show();' . "\n" .
			'$("#lan_gateway").show();' . "\n" .
			'$("#lan_dns1").show();' . "\n" .
			'$("#lan_dns2").show();' . "\n" .
			'$("#lan_mtusize").show();' . "\n" .
			'}' . "\n" .
			'}' . "\n" .
			'</script>' . "\n" .
			'<br/>' . "\n" .
			'<form class="extensions_form" name="networkform" id="networkform" method="POST" action="" onsubmit="return (checkvlan(vlanenable.checked));">' . "\n" .
			'<input type="hidden" name="action" value="apply" />' . "\n" .
			'<table id="table" class="contenttoc" width="35%">' . "\n" .
			'<tr><th colspan="2">' . NETWORK_TABLE_HEADER_DIS . '</th></tr>' . "\n" .
			'<tr>' . "\n" .
			'<td colspan="2" align="center">' . "\n" .
			'<input type="radio" name="dhcp" id="lan_dhcp" onclick="hide_netconfig(document.getElementById(\'lan_static\').checked);" onmouseover=\'Tip("' . NET_CONF_DHCP . '")\' onmouseout="UnTip()" value="yes"' . ($dhcp ? ' checked' : '') . ' />' .
			'DHCP' . "\n" .
			'<input type="radio" name="dhcp" id="lan_static" onclick="hide_netconfig(document.getElementById(\'lan_static\').checked);" onmouseover=\'Tip("' . NET_CONF_STATIC . '")\' onmouseout="UnTip()" value="no"' . ($dhcp ? '' : ' checked') . ' " />' .
			NETWORK_STATIC_DIS . "\n" .
			'</td>' . "\n" .
			'</tr>' . "\n" .
			'<tr id="lan_ipaddr">' . "\n" .
			'<td style="text-align:center"><b><label for="ipaddr">' . NETWORK_IP_ADDRESS_DIS . '</label>:</b></td>' . "\n" .
			'<td><input name="ipaddr" type="text" size="15" id="ipaddr" onmouseover=\'Tip("' . NET_CONF_IP_ADDRESS . '")\' onmouseout="UnTip()" value="' . $bc->get('root', 'lan-ipaddr') . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr id="lan_netmask">' . "\n" .
			'<td style="text-align:center"><b><label for="netmask">' . NETWORK_NETMASK_DIS . '</label>:</b></td>' . "\n" .
			'<td><input name="netmask" type="text" size="15" id="netmask" onclick="if (netmask.value==\'\') netmask.value=makeNetMask(ipaddr.value);"' .
			'onmouseover=\'Tip("' . NET_CONF_NETMASK . '")\' onmouseout="UnTip()" value="' . $bc->get('root', 'lan-netmask') . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr id="lan_gateway">' . "\n" .
			'<td style="text-align:center"><b><label for="gateway">' . NETWORK_GATEWAY_DIS . '</label>:</b></td>' . "\n" .
			'<td><input name="gateway" type="text" size="15" id="gateway" onmouseover=\'Tip("' . NET_CONF_GATEWAY . '")\' onmouseout="UnTip()" value="' . $bc->get('root', 'lan-gateway') . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr id="lan_dns1">' . "\n" .
			'<td style="text-align:center"><b><label for="lan_nameserver">' . NETWORK_PRIMARY_NAME_SERVER_DIS . '</label>:</b></td>' . "\n" .
			'<td><input name="lan_nameserver" type="text" size="15" id="lan_nameserver" onmouseover=\'Tip("' . NET_CONF_NAMESERVER . '")\' onmouseout="UnTip()" value="' . $dns[0] . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr id="lan_dns2">' . "\n" .
			'<td style="text-align:center"><b>' . NETWORK_SECONDARY_NAME_SERVER_DIS . ':</b></td>' . "\n" .
			'<td><input name="lan_nameserver2" type="text" size="15" id="lan_nameserver2" onmouseover=\'Tip("' . NET_CONF_SECONDARY_NAMESERVER . '")\' onmouseout="UnTip()" value="' . $dns[1] . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr>' . "\n" .
			'<td style="text-align:center"><b>' . NETWORK_HOSTNAME_DIS . ':</b></td>' . "\n" .
			'<td><input name="hostname" type="text" size="15" checkDigChar="true" id="hostname" value="' . $ba->get('hostname') . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr class="'.$simple_class.'"><th colspan="2">' . NETWORK_ADVANCED_DIS . '</th></tr>' . "\n" .
			'<tr class="'.$simple_class.'" id="lan_mtusize">' . "\n" .
			'<td style="text-align:center"><b>' . NETWORK_MTU_SIZE_DIS . ':</b></td>' . "\n" .
			'<td><input name="lan_mtu" type="text" size="15" id="lan_mtu" onmouseover=\'Tip("' . NET_CONF_MTU_SIZE . '")\' onmouseout="UnTip()" value="' . $bc->get('root', 'lan-mtu') . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr class="'.$simple_class.'">' . "\n" .
			'<td><b>' . NETWORK_AVAHI_DIS . ':</b></td>' . "\n" .
			'<td><input type="checkbox" name="beroAvahi-enabled" value="1"' . (($bc->get('root', 'beroAvahi-enabled') == '1') ? ' checked' : '') . ' /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr class="'.$simple_class.'">' . "\n" .
			'<td><b>' . NETWORK_CONFIG_SERVER_DIS . ':</b></td>' . "\n" .
			'<td><input type="checkbox" name="disable_ncs" value="1"' . (($bc->get('root', 'disable_ncs') == '1') ? ' checked' : '' ) . ' /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr class="'.$simple_class.'">' . "\n" .
			'<td style="text-align:center"><b>' . NETWORK_VLAN_ENABLE_DIS . ':</b></td>' . "\n" .
			'<td><input name="vlanenable" type="checkbox" id="vlanenable" onclick="show_vlan(document.getElementById(\'vlanenable\').checked);" value="1"' . (($bc->get('root', 'vlan-enable') == 1) ? ' checked' : '') . '/></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr class="'.$simple_class.'" id="vlan_id">' . "\n" .
			'<td style="text-align:center"><b><label for="vlanid">' . NETWORK_VLAN_ID_DIS . '</label>:</b></td>' . "\n" .
			'<td><input name="vlanid" type="text" size="15" id="vlanid" value="' . $bc->get('root', 'vlan-id') . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr class="'.$simple_class.'" id="vlan_prio">' . "\n" .
			'<td style="text-align:center"><b>' . NETWORK_VLAN_PRIORITY_DIS . ':</b></td>' . "\n" .
			'<td>' . $this->vlan_prio() . '</td>' . "\n" .
			'</tr>' . "\n" .
			$this->routing($simple_class) . "\n" .
			'<tr class="'.$simple_class.'" id="add_route">' . "\n" .
			'<td style="text-align:center" colspan="2"><input type="button" id="add_route_button" value="' . BUTTON_ADD_ROUTE_ENTRY . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr>' . "\n" .
			'<td colspan="2" align="center"><input type="submit" name="Apply" value="' . BUTTON_SAVE . '" onmouseover=\'Tip("' . NET_CONF_APPLY . '")\' onmouseout="UnTip()" /></td>' . "\n" .
			'</tr>' . "\n" .
			'</table>' . "\n" .
			'</form>' . "\n" .
			'<div class="center"><i>'.REQUIRED_FIELDS.'</i></div>'. "\n" .
			'<br />' . "\n" .
			$this->httpsSettingTable() .
			'<script>
                            $( "#networkform" ).validate({
                                rules: {
                                    lan_mtu: {
                                        digits: true,
                                        range: [150, 1500]
                                    },
                                    vlanid: {
                                        digits: true,
                                        required: true,
                                        range: [1, 4094]
                                    },
                                    ipaddr: {
                                        verifyIP: "#lan_static:checked",
                                        required: "#lan_static:checked"
                                    },
                                    lan_nameserver: {
                                        verifyIP: "#lan_static:checked",
                                        required: {
                                            depends: function (element) {
                                                return $("#lan_nameserver2").is(":filled");
                                            }
                                        }
                                    },
                                    lan_nameserver2: {
                                        verifyIP: "#lan_static:checked",
                                    },
                                    gateway: {
                                        verifyIP: "#lan_static:checked",
                                        required: "#lan_static:checked"
                                    },
                                    netmask: {
                                        verifyIP: "#lan_static:checked",
                                        required: "#lan_static:checked"
                                    },

                                }
                            });
			    $( "#lan_static" ).change(function() {
				required();
				});
			    $( "#lan_dhcp" ).change(function() {
				required();
				});
			    $( "#lan_nameserver2" ).keyup(function() {
				required();
				});
			    function required(){
				if ($("#lan_static").is(":checked")) {
					addAsterisk( "gateway" );
					addAsterisk( "netmask" );
					addAsterisk( "ipaddr" );
				    }else{
					deleteAsterisk("gateway");
					deleteAsterisk( "netmask" );	  
					deleteAsterisk( "ipaddr" );	  
				}
				if ($("#lan_nameserver2").is(":filled")){
					addAsterisk("lan_nameserver");
				}else{
					deleteAsterisk("lan_nameserver");
				}
			    }
			    required();
                            hide_netconfig(document.getElementById("lan_static").checked);
                            show_vlan(document.getElementById("vlanenable").checked);
				$("#add_route_button").click(function() {
					$("#add_route").before("<tr>"+
						"<td><b>Route target</b></td>"+
						"<td><input name=\'route_net[]\' verifyIP=\'true\' class=\'net\'>/<input name=\'route_netmask[]\' size=\'2\' class=\'netmask\' digits=\'true\' required=\'true\' min=\'0\' max=\'32\' maxlength=\'2\'></td>"+
						"</tr>"+
						"<tr>"+
						"<td><b>Route gateway</b></td>"+
						"<td><input name=\'route_gateway[]\' verifyIP=\'true\' class=\'gateway\' size=\'24\'></td>"+
                                            "</tr>");
				});
				
			</script>';

		return($ret);
	}

	/*
	 * Der boolesche Wert von httpsOnly, der in der Datenbank gespeichert ist wird zurückgegeben
	 * in der Form eines Checkboxs und nachher angezeigt.
	 */

	function https_only() {
		$ba = new beroAri();
		$proxy_enable = $ba->get("httpsOnly");
		if ($proxy_enable == "1")
			return "<input type='hidden' name='httpsOnly' value='0'><input type='checkbox' name='httpsOnly' value='1' checked>";
		else
			return "<input type='hidden' name='httpsOnly' value='0'><input type='checkbox' name='httpsOnly' value='1'>";
	}

	function httpsSettingTable() {
		$table = "<form class='extensions_form' ENCTYPE=\"multipart/form-data\" action='' method='POST'>
					<input type=hidden name=m value=" . $_GET['m'] . ">
					<table class='contenttoc'>
					<tr>
					<th colspan='2'>" . HTTPS_TABLE_HEADER_DIS . "</th>
					</tr>
					<tr>
					<td><b>" . HTTPS_UPLOAD_CERTIFICATE_DIS . ":</b></td>
					<td nowrap><input type='file' size='28' name='uploadfile'></td>
					</tr>";
		if (file_exists("/usr/conf/berofix.pem") && !is_link("/usr/conf/berofix.pem")) {
			$table .= "<tr>
					<td><b>" . HTTPS_CERTIFICATE_DIS . ":</b></td>
					<td><input type='button' value='" . HTTPS_DOWNLOAD_CERTIFICATE_DIS . "' onclick=\" window.location.href='misc/files_download.php?option=certificate_https';\">&nbsp;&nbsp;
					<input type='button' value='" . HTTPS_DELETE_CERTIFICATE_DIS . "' onclick=\"javascript:if (confirm('" . HTTPS_DELETE_CERTIFICATE_MESS_DIS . "?')==true) window.location.href='misc/deletefile.php?m=" . $_GET['m'] . "&option=certificate_https';\"></td>
					</tr>";
		}
		$table .="<tr>
					<td><b>" . HTTPS_ONLY_DIS . ":</b></td>
					<td>" . $this->https_only() . "</td>
					</tr>
                                        <tr>
					<td colspan='2'><input name='submit' type='submit' value='" . BUTTON_SAVE . "'>
					</td>
					</tr>";
		$table .= "</table>
					</form>";
		return $table;
	}

	function vlan_prio() {

		$bc = new beroConf('root');

		$i = 0;
		$ret = '<select name="vlan-prio">' . "\n";
		foreach (array('000', '001', '010', '011', '100', '101', '110', '111') as $bit) {
			$ret .= '<option value="' . $bit . '"' . (($bc->get('root', 'vlan-prio') == $bit) ? ' selected' : '') . '>' . $i++ . '</option>' . "\n";
		}
		$ret .= '</select>' . "\n";

		return($ret);
	}

	function routing($simple_class=null) {

		$bc = new beroConf('root');
		$routing = $bc->get('root', 'routing');

		if (strlen($routing) == 0) {
			return('');
		}

		$res = '';
		foreach (explode(',', $routing) as $route) {
			list($route_net, $route_netmask, $route_gateway) = explode('/', $route);
			$res .= '<tr class="'.$simple_class.'">' . "\n" .
				'<td>Route target</td>' . "\n" .
				'<td>' .
				'<input name="route_net[]" verifyIP="true" class="net" value="' . $route_net . '" /> / <input name="route_netmask[]" digits="true" required="true" min="0" max="32" size="2" maxlength="2" class="netmask" value="' . $route_netmask . '" />' .
				'</td>' . "\n" .
				'</tr>' . "\n" .
				'<tr class="'.$simple_mode.'">' . "\n" .
				'<td>Route gateway</td>' . "\n" .
				'<td><input name="route_gateway[]" verifyIP="true" class="gateway" value="' . $route_gateway . '" size="24" /></td>' . "\n" .
				'</tr>' . "\n";
		}

		return($res);
	}

}

?>
